/**
 * amis v2.0.1
 * Copyright 2018-2022 baidu
 */

import { extendDefaultEnv, render, addRootWrapper, LazyComponent } from 'amis-core';
import { alert, confirm, toast, setRenderSchemaFn, ImageGallery, Spinner } from 'amis-ui';
import React from 'react';

extendDefaultEnv({
    alert: alert,
    confirm: confirm,
    notify: function (type, msg, conf) {
        return toast[type] ? toast[type](msg, conf) : console.warn('[Notify]', type, msg);
    }
});
setRenderSchemaFn(function (controls, value, callback, scopeRef, theme) {
    return render({
        name: 'form',
        type: 'form',
        wrapWithPanel: false,
        mode: 'horizontal',
        controls: controls,
        messages: {
            validateFailed: ''
        }
    }, {
        data: value,
        onFinished: callback,
        scopeRef: scopeRef,
        theme: theme
    }, {
        session: 'prompt'
    });
});
addRootWrapper(function (props) {
    var env = props.env, children = props.children;
    return (React.createElement(ImageGallery, { modalContainer: env.getModalContainer }, children));
});
LazyComponent.defaultProps.placeholder = React.createElement(Spinner, null);
