/**
 * amis v2.0.1
 * Copyright 2018-2022 baidu
 */

import { __extends, __assign } from 'tslib';
import React from 'react';
import hoistNonReactStatic from 'hoist-non-react-statics';
import { filter } from 'amis-core';
import { Icon } from 'amis-ui';

/**
 * @file scoped.jsx.
 * @author fex
 */
var HocCopyable = function () {
    return function (Component) {
        var QuickEditComponent = /** @class */ (function (_super) {
            __extends(QuickEditComponent, _super);
            function QuickEditComponent() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            QuickEditComponent.prototype.handleClick = function (content) {
                var _a = this.props, env = _a.env, copyFormat = _a.copyFormat;
                env.copy && env.copy(content, { format: copyFormat });
            };
            QuickEditComponent.prototype.render = function () {
                var _a = this.props, copyable = _a.copyable, name = _a.name, className = _a.className, data = _a.data, noHoc = _a.noHoc, cx = _a.classnames, __ = _a.translate;
                if (copyable && !noHoc) {
                    var content = filter(copyable.content ||
                        '${' + name + ' | raw }', data);
                    if (content) {
                        return (React.createElement(Component, __assign({}, this.props, { className: cx("Field--copyable", className) }),
                            React.createElement(Component, __assign({}, this.props, { wrapperComponent: '', noHoc: true })),
                            React.createElement("a", { key: "edit-btn", "data-tooltip": __('Copyable.tip'), className: cx('Field-copyBtn'), onClick: this.handleClick.bind(this, content) },
                                React.createElement(Icon, { icon: "copy", className: "icon" }))));
                    }
                }
                return React.createElement(Component, __assign({}, this.props));
            };
            QuickEditComponent.ComposedComponent = Component;
            return QuickEditComponent;
        }(React.PureComponent));
        hoistNonReactStatic(QuickEditComponent, Component);
        return QuickEditComponent;
    };
};

export { HocCopyable, HocCopyable as default };
