/**
 * amis v2.0.1
 * Copyright 2018-2022 baidu
 */

import { __extends, __decorate } from 'tslib';
import React from 'react';
import { getPropValue, resolveVariableAndFilter, isPureVariable, Renderer } from 'amis-core';
import { Tag } from 'amis-ui';

var TagField = /** @class */ (function (_super) {
    __extends(TagField, _super);
    function TagField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TagField.prototype.render = function () {
        var _a = this.props, label = _a.label, icon = _a.icon, displayMode = _a.displayMode, color = _a.color, className = _a.className, closable = _a.closable, data = _a.data, _b = _a.style, style = _b === void 0 ? {} : _b;
        label =
            getPropValue(this.props) ||
                (label ? resolveVariableAndFilter(label, data, '| raw') : null);
        if (isPureVariable(icon)) {
            icon = resolveVariableAndFilter(icon, data);
        }
        if (isPureVariable(displayMode)) {
            displayMode = resolveVariableAndFilter(displayMode, data);
        }
        if (isPureVariable(color)) {
            color = resolveVariableAndFilter(color, data);
        }
        return (React.createElement(Tag, { className: className, displayMode: displayMode, color: color, icon: icon, closable: closable, style: style }, label));
    };
    TagField.defaultProps = {
        displayMode: 'normal'
    };
    return TagField;
}(React.Component));
/** @class */ ((function (_super) {
    __extends(TagFieldRenderer, _super);
    function TagFieldRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TagFieldRenderer = __decorate([
        Renderer({
            type: 'tag'
        })
    ], TagFieldRenderer);
    return TagFieldRenderer;
})(TagField));

export { TagField };
